#include <functional>

template<typename T>
class HashFunc {
public:
    virtual std::size_t operator()(T &obj) = 0;
};

template<typename T>
class DefaultHashFunc : public HashFunc<T> {
    virtual std::size_t operator()(T &obj){
        return std::hash<T>()(obj);
    }
};

